#!/usr/bin/ruby -w

scr = []

scr_file = File.new(ARGV[0])
scr_file.binmode
scr_file.each_byte { |b|
	scr << b
}
scr_file.close

# attributes
bin1 = File.new("attract1.bin", "w")
bin1.binmode
for y in (0..7)
	scr.slice(0x1800 + y*32, 32).each { |byte| bin1.putc(byte) }
	scr.slice(0x1a00 + y*32, 32).each { |byte| bin1.putc(byte) }
	scr.slice(0x1800 + y*32, 16).each { |byte| bin1.putc(byte) }
end

# right-shifted bitmap
for y in (0..63)
	yaddr = 0x100*(y % 8) + 0x20*(y / 8)
	carry = scr[yaddr + 0x101f] & 0x0f
	for x in (0..31)
		bin1.putc((carry << 4) + (scr[yaddr+x] >> 4))
		carry = scr[yaddr+x] & 0x0f
	end
	for x in (0..31)
		bin1.putc((carry << 4) + (scr[yaddr+0x1000+x] >> 4))
		carry = scr[yaddr+0x1000+x] & 0x0f
	end
	for x in (0..15)
		bin1.putc((carry << 4) + (scr[yaddr+x] >> 4))
		carry = scr[yaddr+x] & 0x0f
	end
end

# 0x03f0 byte gap
0x03f0.times do
	bin1.putc(0)
end

# unshifted bitmap, bottom portion
for y in (51..63)
	yaddr = 0x100*(y % 8) + 0x20*(y / 8)
	scr.slice(yaddr, 32).each { |byte| bin1.putc(byte) }
	scr.slice(0x1000 + yaddr, 32).each { |byte| bin1.putc(byte) }
	scr.slice(yaddr, 16).each { |byte| bin1.putc(byte) }
end
bin1.close

bin2 = File.new("attract2.bin", "w")
bin2.binmode
# unshifted bitmap, top portion
for y in (0..50)
	yaddr = 0x100*(y % 8) + 0x20*(y / 8)
	scr.slice(yaddr, 32).each { |byte| bin2.putc(byte) }
	scr.slice(0x1000 + yaddr, 32).each { |byte| bin2.putc(byte) }
	scr.slice(yaddr, 16).each { |byte| bin2.putc(byte) }
end
bin2.close
