		include "globals.sym"

		org 25000
		; startup
				
		call stc_init_entry
		; set up interrupts
		di
		ld a,0xaf
		ld i,a
		im 2
		ei
		call bading
		call game_logo
		call attract
		
		ld a,0x13
		call safe_page
		include "page3.sym"

		ld hl,i81_source
		ld de,0x8000
		ld bc,i81_len
		ldir
		include "interrupt_81.sym"

		; ensure int81 also knows page 3 is paged in
		; (currently hard-coded into interrupt_81.asm)
		; ld a,0x13
		; call safe_page_81

		ld a,0x80
		ld i,a
		
		; now copy stars part into place
		ld hl,stars_p3_source
		ld de,0x8200
		ld bc,stars_p3_len
		ldir
		ld a,0x14
		call safe_page_81
		call 0x8200	; stars

		; rasters
		ld a,0x16
		call safe_page_81
		ld hl,raster_src
		ld de,0x8200
		ld bc,raster_len
		ldir
		
		ld a,0x14
		call safe_page_81
		
		ld hl,0x8200
		ld d,h
		ld e,l
		call dehrust
		
		call 0x8200	; rasters

		ld a,0x11
		call safe_page_81
		include "page1.sym"
		
		ld hl,kickin_src
		ld de,0x4000
		call dehrust
		
		ld hl,disco_src
		ld de,0x8200
		call dehrust

;		ld b,160			; todo: make this a wait_for_frame
;zzz_kickin
;		halt
;		halt
;		djnz zzz_kickin

		ld de,3500 ; 3520 - wtf?
		call wait_for_frame_81
		
		call 0x8200
		
		ld hl,endscreen_src
		ld de,0x4000
		call dehrust

		; let music finish
		ld b,50
finalwait
		halt
		djnz finalwait

		di
		im 1
		ei
		ld a,0x16
		call safe_page_81
		call stc_init
		
die		jr die

wait_for_frame
		ld hl,(frame_counter)
		or a
		sbc hl,de
		ret nc
		halt
		jr wait_for_frame

		include "interrupt_ae.sym"
		org 0xaeae
		incbin "interrupt_ae.bin"

		; attract.asm takes up various (most) locations in page 2
		; and also 0x7d90-0x7fff
		include "attract.asm"
		
; page 6
		include "music.sym"
		org 0xc000
		incbin "music.bin"

game_logo
		include "game_logo.asm"
bading
		include "bading.asm"
raster_src
		incbin "raster.bin.hru"
raster_len	equ $ - raster_src