align		macro n
			org ($ + n - 1) / n * n
			endm
			
;			org 0x8000
			include "interrupt_81.sym"
			
			org 0x8200

; offsets into 'bar'
; c1, c3 = left; c2, c4 = right
; c0 = the previous bar's c4

handle0		equ 1		; c3c1 x 2
handle1		equ 7		; c0
handle2		equ 17		; c1
handle3		equ 22		; c2c1 x 2
handle4		equ 34		; c2c4 x 2
handle5		equ 47		; c2
handle6		equ 53		; c3c4 x 2
handle7		equ 63		; c3
barlen		equ 66

bar		macro pos,c1,c2,c3,c4,c0
			ld bc,0x0101 * (c1 + c3*8)	; handle 0
			ld sp,pos + 0x0006

			ld a,c0						; handle 1
			out (254),a

			push bc
			push bc
			push bc
			ld sp,pos + 0x000c
			ld a,c1						; handle 2
			push bc
			push bc
			push bc

			ld bc,0x0101 * (c1 + c2*8)	; handle 3
			ld sp,pos + 0x0014
			out (254),a
			push bc
			push bc
			push bc
			push bc

			ld bc,0x0101 * (c4 + c2*8)	; handle 4
			ld sp,pos + 0x001c
			push bc
			push bc
			push bc
			push bc
			ld sp,pos + 0x0020
			ld a,c2						; handle 5
			push bc
			push bc
			
			out (254),a

			ld bc,0x0101 * (c4 + c3*8)	; handle 6
			ld sp,pos + 0x0014
			push bc
			push bc
			push bc
			push bc
			
			ld a,c3						; handle 7
			out (254),a

		endm

; copy images onto screens
			ld hl,this_is_possible
			ld de,0x5000
			ld bc,0x0800
			ldir

			ld hl,0x5a00
			ld de,0x5a01
			ld c,0xff
			ld (hl),0x47
			ldir
		
			ld a,0x17
			call safe_page_81
			ld hl,this_isnt
			ld de,0xd000
			ld bc,0x0800
			ldir
			
			ld hl,0xd9a0
			ld (hl),0
			ld de,0xd9a1
			ld bc,0x5f
			ldir

			ld hl,0xda00
			ld de,0xda01
			ld c,0xff
			ld (hl),0x47
			ldir
		
			ld a,0x14
			call safe_page_81

; fill screen with ink/paper lines
			ld hl,0x5800
			ld de,0x5801
			ld (hl),l
			ld bc,0x01ff
			ldir

			ld hl,0x4000
			ld de,0x4001
			ld (hl),l
			ld bc,0x0fff
			ldir
			
			ld hl,bmp0
			ld de,0x4000
			ld bc,0x0020
			ldir
			ld hl,0x4000
			ld bc,0x00e0
			ldir
			
			ld hl,bmp1
			ld bc,0x0020
			ldir
			ld hl,0x4100
			ld bc,0x00e0
			ldir
			
			ld hl,0x4000
			ld bc,0x0e00
			ldir

;set up interrupts		
			ld hl,0x8181
			ld (hl),0xC3	; opcode for JP
			ld hl,interrupt
			ld (0x8182),hl
		
			ld bc,640
			call waitlp

			ld a,0x1c
			ld (caption+1),a
			ld a,0x2d		; opcode for DEC L
			ld (sinedir),a
			ld bc,320
			call waitlp

			ld a,raster_colours_2 / 0x0100
			ld (palette+1),a

			ld bc,320
			call waitlp
			
			; put back interrupts
			ld hl,0x8181
			ld (hl),0xf5
			ld hl,0xd5c5
			ld (0x8182),hl
			
			xor a
			out (254),a
			ld hl,0x5800
			ld de,0x5801
			ld (hl),l
			ld bc,0x02ff
			ldir
			
			ret
		
waitlp
			halt
			push bc
; set colours
colpos2		ld hl,widesine+30						; right panel
sinedir		inc l
			ld (colpos2+1),hl
			ld l,(hl)
palette
			ld h,raster_colours / 0x0100
			ld d,0x38
			exx
			ld b,52
			ld de,barlen
			ld ix,barstart
colpos1		ld hl,widesine+30			; left panel (c1, c3)
			inc l
			ld (colpos1+1),hl
			ld l,(hl)
			ld h,raster_colours / 0x0100

;colpos2		ld hl,raster_colours						; right panel
;			inc l
;			ld (colpos2+1),hl
;			ld d,0x38
;			exx
;			ld b,52
;			ld de,barlen
;			ld ix,barstart
;colpos1		ld hl, raster_colours			; left panel (c1, c3)
;			dec l
;			ld (colpos1+1),hl

setcolours_lp
;c=c1 (set handle2)
;a=c3 (set handle7)
;a<<3, or with c (set handle0)		a = c3c1
;exx
;b=c2 (set handle5)
;c=c4 (set handle1 in next bar)
;a&38, or with c (set handle6)		a = c3c4
;a=b, a<<3, or with c (set handle4)	a = c2c4
;exx
;a&38, or with c (set handle3)		a = c2c1
; or, in code:

			ld c,(hl)		; read c1
			inc l
			ld (ix+handle2),c
			ld a,(hl)		; read c3
			inc l
			ld (ix+handle7),a
			sla a
			sla a
			sla a
			or c
			ld (ix+handle0),a
			ld (ix+handle0+1),a
			exx
			ld b,(hl)		; read c2
			inc l
			ld (ix+handle5),b
			ld c,(hl)		; read c4
			inc l
			ld (ix+handle1+barlen),c
			and d
			or c
			ld (ix+handle6),a
			ld (ix+handle6+1),a
			ld a,b
			sla a
			sla a
			sla a
			or c
			ld (ix+handle4),a
			ld (ix+handle4+1),a
			and d
			exx
			or c
			ld (ix+handle3),a
			ld (ix+handle3+1),a

			add ix,de
			djnz setcolours_lp
			
			ld a,(sinepos1+1)
			dec a
			ld (sinepos1+1),a
			ld a,(sinepos2+1)
			inc a
			inc a
			ld (sinepos2+1),a
			
;			ld a,2
;			out (254),a

			ld a,0x14
			call safe_page_81

			pop bc
			dec bc
			ld a,b
			or c			
			jp nz,waitlp

			ret
			
this_is_possible
			incbin "possible.bin"
this_isnt
			incbin "this_isnt.bin"

interrupt
			push af
			push bc

			ld (spback+1),sp
		
			ld a,0;1
			out (254),a
		
drawsine	macro up
				exx
				ld a,(de)
				inc e
				add a,(hl)
				inc l
				exx
				ld l,a
				ld e,(hl)
				if up
					inc h
				else
					dec h
				endif
				ld a,(hl)
				ex de,hl
				if up
					ld (hl),b	; 0
				else
					ld (hl),c	; 255
				endif
				inc l
				ld (hl),a
				inc l
				if up
					ld (hl),c	; 255
				else
					ld (hl),b	; 0
				endif
			endm

ds8			macro
				drawsine 0
				ex de,hl
				inc h
				inc d
				drawsine 1
				ex de,hl
				dec h
				inc d
				drawsine 0
				ex de,hl
				inc h
				inc d
				drawsine 1
				ex de,hl
				dec h
				inc d
				drawsine 0
				ex de,hl
				inc h
				inc d
				drawsine 1
				ex de,hl
				dec h
				inc d
				drawsine 0
				ex de,hl
				inc h
				inc d
				drawsine 1
			endm

sinepos1	ld de,doublesine
sinepos2	ld hl,sine+20
			exx
			ld bc,0x00ff

			ld h,drawtbl/256+1
			ld d,0x40
			ds8
			ld h,drawtbl/256+4
			ld d,0x40
			ds8
			ld h,drawtbl/256+7
			ld d,0x40
			ds8
			ld h,drawtbl/256+10
			ld d,0x40
			ds8
			ld h,drawtbl/256+13
			ld d,0x40
			ds8
			ld h,drawtbl/256+16
			ld d,0x40
			ds8
			ld h,drawtbl/256+19
			ld d,0x40
			ds8
			ld h,drawtbl/256+22
			ld d,0x40
			ds8
			ld h,drawtbl/256+1
			ld d,0x48
			ds8
			ld h,drawtbl/256+4
			ld d,0x48
			ds8
			ld h,drawtbl/256+7
			ld d,0x48
			ds8
			ld h,drawtbl/256+10
			ld d,0x48
			ds8
			ld h,drawtbl/256+13
			ld d,0x48
			ds8
;			ld h,drawtbl/256+16
;			ld d,0x48
;			ds8
;			ld h,drawtbl/256+19
;			ld d,0x48
;			ds8
;			ld h,drawtbl/256+22
;			ld d,0x48
;			ds8
						
			ld bc,149
zzz
			dec bc
			ld a,b
			or c
			jr nz,zzz
			nop
			nop
;			nop
			nop
			;ld a,(hl)		; 7 tstates (watch out for contention!)
			
			ld a,0
			out (254),a

barstart
			bar 0x5800,1,2,3,4,0
			bar 0x5800,5,6,7,0,4
			bar 0x5800,1,2,3,4,0
			bar 0x5800,5,6,7,0,4
			bar 0x5820,1,2,3,4,0
			bar 0x5820,5,6,7,0,4
			bar 0x5820,1,2,3,4,0
			bar 0x5820,5,6,7,0,4
			bar 0x5840,1,2,3,4,0
			bar 0x5840,5,6,7,0,4
			bar 0x5840,1,2,3,4,0
			bar 0x5840,5,6,7,0,4
			bar 0x5860,1,2,3,4,0
			bar 0x5860,5,6,7,0,4
			bar 0x5860,1,2,3,4,0
			bar 0x5860,5,6,7,0,4
			bar 0x5880,1,2,3,4,0
			bar 0x5880,5,6,7,0,4
			bar 0x5880,1,2,3,4,0
			bar 0x5880,5,6,7,0,4
			bar 0x58a0,1,2,3,4,0
			bar 0x58a0,5,6,7,0,4
			bar 0x58a0,1,2,3,4,0
			bar 0x58a0,5,6,7,0,4
			bar 0x58c0,1,2,3,4,0
			bar 0x58c0,5,6,7,0,4
			bar 0x58c0,1,2,3,4,0
			bar 0x58c0,5,6,7,0,4
			bar 0x58e0,1,2,3,4,0
			bar 0x58e0,5,6,7,0,4
			bar 0x58e0,1,2,3,4,0
			bar 0x58e0,5,6,7,0,4
			bar 0x5900,1,2,3,4,0
			bar 0x5900,5,6,7,0,4
			bar 0x5900,1,2,3,4,0
			bar 0x5900,5,6,7,0,4
			bar 0x5920,1,2,3,4,0
			bar 0x5920,5,6,7,0,4
			bar 0x5920,1,2,3,4,0
			bar 0x5920,5,6,7,0,4
			bar 0x5940,1,2,3,4,0
			bar 0x5940,5,6,7,0,4
			bar 0x5940,1,2,3,4,0
			bar 0x5940,5,6,7,0,4
			bar 0x5960,1,2,3,4,0
			bar 0x5960,5,6,7,0,4
			bar 0x5960,1,2,3,4,0
			bar 0x5960,5,6,7,0,4
			bar 0x5980,1,2,3,4,0
			bar 0x5980,5,6,7,0,4
			bar 0x5980,1,2,3,4,0
			bar 0x5980,5,6,7,0,4
;			bar 0x59a0,1,2,3,4,0
;			bar 0x59a0,5,6,7,0,4
;			bar 0x59a0,1,2,3,4,0
;			bar 0x59a0,5,6,7,0,4
;			bar 0x59c0,1,2,3,4,0
;			bar 0x59c0,5,6,7,0,4
;			bar 0x59c0,1,2,3,4,0
;			bar 0x59c0,5,6,7,0,4
;			bar 0x59e0,1,2,3,4,0
;			bar 0x59e0,5,6,7,0,4
;			bar 0x59e0,1,2,3,4,0
;			bar 0x59e0,5,6,7,0,4

			; the final border change - carefully placed at a
			; matching byte offset to the rest
			; ld bc,0x0101 * (c1 + c3*8)	; handle 0
			; ld sp,pos + 0x0006
			db 0,0,0
spback		ld sp,0

			ld a,0
			out (254),a

caption
			ld a,0x14
			call safe_page_81
			
			ld b,4
zzzafter		; ensure the final border stripe remains for the rest of the rasterline
			djnz zzzafter
			xor a
			out (254),a

			pop bc
			pop af
; segue into the 'proper' interrupt routine
			push af
			push bc
			push de
			
			jp 0x8184

			ei
			ret

bmp0		db 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
			db 0xff,0xff,0xff,0xff,0xff,0xf0,0x00,0x00,0x00,0x00,0x00,0x00
			db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
			
bmp1		db 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
			db 0x00,0x00,0x00,0x00,0x00,0x03,0xff,0xff,0xff,0xff,0xff,0xff
			db 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff
			
			align 0x100
raster_colours
			db 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,0,2,4,6,1,3,5,7,7,5,3,1,6,4,2,0
			
			db 0,7,6,7,1,0,7,0,2,1,0,1,3,2,1,2,4,3,2,3,5,4,3,4,6,5,4,5,7,6,5,6
			db 6,5,6,7,5,4,5,6,4,3,4,5,3,2,3,4,2,1,2,3,1,0,1,2,0,7,0,1,7,6,7,0
			
			db 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,0,2,4,6,1,3,5,7,7,5,3,1,6,4,2,0

			db 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,0,2,4,6,1,3,5,7,7,5,3,1,6,4,2,0

			db 0,7,6,7,1,0,7,0,2,1,0,1,3,2,1,2,4,3,2,3,5,4,3,4,6,5,4,5,7,6,5,6
			db 6,5,6,7,5,4,5,6,4,3,4,5,3,2,3,4,2,1,2,3,1,0,1,2,0,7,0,1,7,6,7,0
			
			db 0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,0,2,4,6,1,3,5,7,7,5,3,1,6,4,2,0
			
raster_colours_2
			db 0,2,0,3,2,3,6,2,3,6,7,6,7,0,0,0,0,0,0,7,6,7,6,6,3,6,3,2,3,0,2,0
			db 0,2,0,4,0,4,5,2,4,5,7,5,7,0,0,0,0,0,0,7,5,7,5,5,4,5,4,2,4,0,2,0
			db 0,2,0,3,2,3,6,2,3,6,7,6,7,0,0,0,0,0,0,7,6,7,6,6,3,6,3,2,3,0,2,0
			db 0,2,0,4,0,4,5,2,4,5,7,5,7,0,0,0,0,0,0,7,5,7,5,5,4,5,4,2,4,0,2,0
			db 0,2,0,3,2,3,6,2,3,6,7,6,7,0,0,0,0,0,0,7,6,7,6,6,3,6,3,2,3,0,2,0
			db 0,2,0,4,0,4,5,2,4,5,7,5,7,0,0,0,0,0,0,7,5,7,5,5,4,5,4,2,4,0,2,0
			db 0,2,0,3,2,3,6,2,3,6,7,6,7,0,0,0,0,0,0,7,6,7,6,6,3,6,3,2,3,0,2,0
			db 0,2,0,4,0,4,5,2,4,5,7,5,7,0,0,0,0,0,0,7,5,7,5,5,4,5,4,2,4,0,2,0
			
			align 0x0100
sine
			include "sine.asm"
widesine
			include "widesine.asm"
doublesine
			include "doublesine.asm"
		
drawtblblock	macro k
					align 0x0100
					rept 8
					db 0x00,0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe
					endm
					align 0x0100
					rept 8
					db 0x0b+k
					endm
					rept 8
					db 0x0c+k
					endm
					rept 8
					db 0x0d+k
					endm
					rept 8
					db 0x0e+k
					endm
					rept 8
					db 0x0f+k
					endm
					rept 8
					db 0x10+k
					endm
					rept 8
					db 0x11+k
					endm
					rept 8
					db 0x12+k
					endm
					align 0x0100
					rept 32
					db 0xff,0x7f,0x3f,0x1f,0x0f,0x07,0x03,0x01
					endm
				endm

drawtbl
			drawtblblock 0x00
			drawtblblock 0x20
			drawtblblock 0x40
			drawtblblock 0x60
			drawtblblock 0x80
			drawtblblock 0xa0
			drawtblblock 0xc0
			drawtblblock 0xe0
			