#!/usr/bin/ruby -w

require 'rubygems'
require 'RMagick'
require 'delta_compressor'
# include Magick

def frame(f)
	canvas = Magick::Image.new(256, 192) {
		self.format = 'mono'
		self.background_color = 'black'
	}
	gc = Magick::Draw.new
	
	gc.fill('white')
	
	u = f.to_f / ($frame_count * 3)
	for s in (0..2)
		t = u + s.to_f/3
		th = Math::PI*t
		r = Math.sin(3*th)
		a = 4*t*Math::PI/5 # or 2*t*...
		
		sr = th + (s*2+1)*Math::PI/3
		canvas.composite!(
			star($ampl*r*Math.sin(th) + 128,
				$ampl*r*Math.cos(th) + 88,
				a,
				Math.sin(2*th)/10 + 0.3),
			0,32,
			Magick::DifferenceCompositeOp
		)
	end
	
	return canvas
end

def star (x, y, rota, scale)
	# x = 128
	# y = 96
	# rota = 36
	# scale = 0.7
	star_image = Magick::Image.new(256, 192) {
		self.format = 'mono'
		self.background_color = 'black'
	}
	gc = Magick::Draw.new
	
	gc.fill('white')
	
	gc.translate(x,y)
	gc.rotate(rota * 180 / Math::PI)
	gc.scale(scale, scale)
	gc.polygon(0,    0-122,     29, 86-122,  109, 86-122,
	           47, 140 -122, 73, 226 -122, 0,     175 -122,
	           -73, 226 -122, -47, 140 -122, -109, 86 -122,
	           -29, 86 -122)
	
	gc.draw(star_image)
	star_image.sample!(256,128)
	return star_image
end

$frame_count = 44
$ampl = 48

dc = DeltaCompressor.new(frame($frame_count-1))
for frame_no in (0...$frame_count)
	STDERR.puts "processing frame #{frame_no}"
	scr = frame(frame_no)
	# scr.write("frames/frame#{frame_no}.png")
	dc.compress(scr)
end

STDERR.puts "Total length: #{dc.output.length}"
print dc.output.pack("C*")