#!/usr/bin/ruby -w

# convert an xbm image to a screen third

xbm = File.new(ARGV[0])
bytes = [];
xbm.each { |line|
	next unless line =~ /^\s/
	line.scan(/0x../) { |bytecode|
		byte = Integer(bytecode)
		# switch bit ordering
		newbyte = 0
		(0..7).each do |i|
			if (byte & (1 << i) > 0)
				newbyte |= (1 << (7-i))
			end
		end

		bytes.push(newbyte);
	}
}

bytelines = []
0.step(bytes.length - 1, 32) { |i|
	bytelines.push(bytes.slice(i, 32));
}

for char in (0..7)
	for y in (0..7)
		bytelines[char + y*8].each do |byte|
			print((255-byte).chr)
		end
	end
end